4 # Copyright (C) 2007 Daniel Hokka Zakrisson
6 # This program is free software; you can redistribute it and/or modify
7 # it under the terms of the GNU General Public License as published by
8 # the Free Software Foundation; version 2 of the License.
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13 # GNU General Public License for more details.
15 # You should have received a copy of the GNU General Public License
16 # along with this program; if not, write to the Free Software
17 # Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
19 : ${UTIL_VSERVER_VARS:=/usr/lib/util-vserver/util-vserver-vars}
20 test -e "$UTIL_VSERVER_VARS" || {
21 echo $"Can not find util-vserver installation (the file '$UTIL_VSERVER_VARS' would be expected); aborting..." >&2
24 . "$UTIL_VSERVER_VARS"
31 $"Usage: $0 <vserver-name> -- [-o options] [--bind|--rbind]
32 [-t <type>] [-a] [-n] [--move]
33 [<source> [<destination>]]
35 <source> ... what to mount, this is relative to the host's root
36 <destination> ... where to mount it, this is relative to the guest's root
38 Report bugs to <$PACKAGE_BUGREPORT>."
42 function showVersion()
45 $"vmount $PACKAGE_VERSION -- mount for guests
46 This program is part of $PACKAGE_STRING
48 Copyright (C) 2007 Daniel Hokka Zakrisson
49 This program is free software; you may redistribute it under the terms of
50 the GNU General Public License. This program has absolutely no warranty."
56 while test $# -gt 0; do
62 guests=( "${guests[@]}" "$VSERVER_DIR" )
68 tmp=$(getopt -o +o:t:an --long help,version,debug,bind,rbind,move -n "$0" -- "$@") || exit 1
75 (--help) showHelp $0 ;;
76 (--version) showVersion ;;
78 (--bind|--rbind|--move|-n|-a)
79 options=( "${options[@]}" "$1" )
81 (-t|-o) options=( "${options[@]}" "$1" "$2" )
85 (*) echo $"vmount: internal error; arg=='$1'" >&2; exit 1;;
92 (*) panic $"vmount: the source must be an absolute path";;
96 for guest in "${guests[@]}"; do
97 pushd "$guest/vdir" &> /dev/null
98 callInNamespace "$guest" \
99 $_SECURE_MOUNT --chroot --fstab "$guest/fstab" "${options[@]}" "$@"
100 test "$?" -eq 0 || rc=$?